<?xml version='1.0' encoding='UTF-8' ?>
<!DOCTYPE composition PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<ui:composition xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
                xmlns="http://www.w3.org/1999/xhtml"
                template="./../plantilla-principal.xhtml"
                xmlns:jsf="http://xmlns.jcp.org/jsf"
                xmlns:h="http://xmlns.jcp.org/jsf/html"
                xmlns:f="http://xmlns.jcp.org/jsf/core">

    <ui:define name="contenido">
        <h2 class="ui header">Registro de cobros</h2>
        <div class="ui secondary menu">

            <div class="ui fitted item">
                <button id="btn-nuevo" class="ui green button" onclick="$('#form-acciones\\:cml-nuevo').click();">
                    <i class="file icon" />
                    Nuevo
                </button>
            </div>

            <div class="ui fitted item">
                <button id="btn-reg" class="ui teal button" style="display: none;" >
                    <i class="save icon" />
                    Registrar
                </button>
            </div>
            <h:form id="form-acciones">
                <h:commandLink action="#{registroCobrosManBean.reiniciarCampos()}" id="cml-nuevo" style="display: none;" >
                    <f:ajax execute="@this" render="form-datos:id-transaccion form-datos:fecha-factura form-datos:medio-pago form-datos:total-cobro form-detalle" onevent="function(data){ajaxReiniciarCampos(data)}" />
                </h:commandLink>
                <h:commandLink id="cml-dlg-fin-trans" action="#{registroCobrosManBean.actionVerDlgFinTrans()}" style="display: none;">
                    <f:ajax execute="@this" render="finalizar-trans:tabla-nueva-factura dlg-finalizar-trans:tabla-facturas-existentes" />
                </h:commandLink>
                <h:commandLink id="cml-reg-cobro" action="#{registroCobrosManBean.registrarCobro()}" style="display: none;">
                    <f:ajax execute="@this" render="form-datos:id-transaccion form-datos:fecha-factura form-datos:medio-pago form-datos:total-cobro form-detalle lbl-msg-status" onevent="function(data){ajaxRegistrarCobro(data)}" />
                </h:commandLink>
            </h:form>

        </div>
        <!--</h:form>-->
        <div class="ui grid">
            <div class="six wide column">
                <h:form id="form-datos">
                    <div class="ui form">
                        <div class="field">
                            <label>ID Transacción</label>
                            <input jsf:id="id-transaccion" jsf:value="#{registroCobrosManBean.cobroVar.idcobro}" type="number" disabled="true" />
                        </div>
                        <div class="ui field">
                            <label>Suscripción/Cliente</label>
                            <div id="cmb-busq-susc" class="ui search selection dropdown">
                                <input jsf:value="#{registroCobrosManBean.idSuscSelec}" jsf:id="txf-suscripcion" name="txf-suscripcion" type="hidden" />
                                    <i class="dropdown icon"></i>
                                    <div class="default text">Suscripción</div>
                                    <div class="menu">
                                    </div>
                            </div>
                            <!--                            <div id="tx-busq-susc" class="ui search selection dropdown">
                                                            <div id="txf-buscar-cli" class="ui icon input">
                                                                <input id="in-buscar-susc" class="prompt" placeholder="Buscar..." type="text"/>
                                                                <i class="search icon" />
                                                            </div>
                                                            <div class="results"></div>
                                                        </div>-->
                            <!--<input type="hidden" jsf:id="txf-suscripcion" jsf:value="#{registroCobrosManBean.idSuscSelec}" />-->
                        </div>
                        <h:commandLink id="cmdlk-selec-susc" style="display: none;" action="#{registroCobrosManBean.seleccionSuscripcion()}">
                            <f:ajax execute="txf-suscripcion @this" render="form-detalle form-detalle:lbl-suscripcion total-cobro" onevent="function(data){ajaxComprobarExistDetalle(data);}" />
                        </h:commandLink>
                        <div class="field" >
                            <label>Fecha</label>
                            <div class="ui calendar">
                                <div class="ui input left icon">
                                    <i class="calendar icon" />
                                    <input id="fecha-factura" jsf:value="#{registroCobrosManBean.txtFechaCobro}" type="text" placeholder="Fecha" />
                                </div>
                            </div>
                        </div>
                        <div class="field">
                            <label>Medio de Pago</label>
                            <div id="medio-pago" class="ui disabled selection dropdown">
                                <input jsf:value="#{registroCobrosManBean.idMedioPagoSelect}" name="medioPago" type="hidden" />
                                <i class="dropdown icon"></i>
                                <div class="default text">Medio de Pago</div>
                                <div class="menu">
                                    <ui:repeat value="#{registroCobrosManBean.lstMediosPagos}" var="mediopago" varStatus="medioagoStatus">
                                        <div class="item" data-value="#{mediopago.idmedioPago}">#{mediopago.nombre}</div>
                                    </ui:repeat>
                                </div>
                            </div>
                        </div>

                        <div class="field">
                            <label>Total (gs.)</label>
                            <div jsf:id="total-cobro" class="ui big red basic fluid label" style="text-align: right;" >
                                <h:outputText value="#{registroCobrosManBean.cobroVar.monto}">
                                    <f:convertNumber pattern="###,###,###,###" />
                                </h:outputText>
                            </div>
                        </div>
                    </div>

                </h:form>
                <div id="msg-status" class="ui hidden info message">
                    <i class="close icon"></i>
                    <div id="titulo-msg" class="header">
                        Agregar Zona
                    </div>
                    <h:outputText id="lbl-msg-status" value="#{registroCobrosManBean.msg}" />
                </div>
            </div>
            <div class="ui ten wide column">

                <h:form id="form-detalle">
                    <div class="ui basic segment" id="lbl-suscripcion">
                        <h:outputText style="font-size: 140%;" rendered="#{registroCobrosManBean.suscSeleccionada != null}" id="lbl-suscripcion" value="#{registroCobrosManBean.suscSeleccionada.idsuscripcion}-#{registroCobrosManBean.suscSeleccionada.cliente.razonSocial} (" />
                        <h:outputText style="font-size: 140%;" value="#{registroCobrosManBean.suscSeleccionada.cliente.ci}" rendered="#{registroCobrosManBean.suscSeleccionada != null}">
                            <f:convertNumber pattern="###,###,###,###" />
                        </h:outputText>
                        <h:outputText  value=")" style="font-size: 140%" rendered="#{registroCobrosManBean.suscSeleccionada != null}"/>
                        <h:outputText rendered="#{registroCobrosManBean.suscSeleccionada != null}" value=" #{registroCobrosManBean.suscSeleccionada.direccion}, barrio #{registroCobrosManBean.suscSeleccionada.barrio.nombre}" />
                    </div>
                    <table jsf:id="tabla-detalle" class="ui violet table">
                        <thead>
                            <tr><th>No. Factura</th>
                                <th>Item</th>
                                <th>Vencimiento</th>
                                <th>Monto</th>
                                <th></th>
                            </tr></thead><tbody id="cuerpo-tabla-detalle">
                                <ui:repeat value="#{registroCobrosManBean.lstCuotasPendientes}" var="cuotapend" varStatus="cuotapendStatus">

                                <tr id="rw-cuota-#{cuotapend.idcuota}" class="#{registroCobrosManBean.getDetalleFCuota(cuotapend.idcuota)==null?'error':''}">
                                    <!--<div>-->
                                    <td jsf:rendered="#{registroCobrosManBean.getDetalleFCuota(cuotapend.idcuota)!=null}">#{registroCobrosManBean.getDetalleFCuota(cuotapend.idcuota)}</td>
                                    <!--</div>-->
                                    <td jsf:rendered="#{registroCobrosManBean.getDetalleFCuota(cuotapend.idcuota)==null}">(Pendiente de generar)</td>
                                    <td>Cuota #{utilConversion.getNombreMes(cuotapend.mesCuota)}/#{cuotapend.anioCuota}</td>
                                    <td>
                                        <h:outputText value="#{cuotapend.fechaVencimiento}">
                                            <f:convertDateTime pattern="dd/MM/yyyy" />
                                        </h:outputText>
                                    </td>
                                    <td>
                                        <h:outputText value="#{cuotapend.montoCuota}">
                                            <f:convertNumber pattern="###,###,###,###" />
                                        </h:outputText>
                                    </td>
                                    <td>
                                        <div class="ui fitted checkbox">
                                            <input disabled='disabled' id="chkdetfact-#{cuotapend.idcuota}" type="checkbox" onclick="calcularTotal()"/>
                                            <label></label>
                                        </div>
                                    </td>
                                </tr>
                            </ui:repeat>
                        </tbody>
                    </table>
                    <div id="sgm-cargando-tabla" class="ui center aligned basic segment" style="display: none;">
                        <i class="big notched circle grey loading icon" />
                    </div>


                    <input jsf:id="iddetalles-cobrar" type="hidden" jsf:value="#{registroCobrosManBean.JSONIdDetallesCobrar}" />
                    <h:commandLink style="display: none;" id="cmd-calc-total" action="#{registroCobrosManBean.calculoTotalCobro()}">
                        <f:ajax execute="@this form-detalle:iddetalles-cobrar" render="form-datos:total-cobro" />
                    </h:commandLink>
                </h:form>
                <div id="msg-sin-cuotas" class="ui hidden info message">
                    <i class="close icon"></i>
                    <div class="header">
                        Al día
                    </div>
                    Esta suscripción no tiene cuotas pendientes
                </div>
            </div>
        </div>
        <h:form id="dlg-finalizar-trans" class="ui modal">
            <i class="close icon"></i>
            <div class="header">
                Finalizar transacción
            </div>
            <div class="content">
                <div class="ui header">Facturas Anteriores</div>
                <p>
                    <table jsf:id="tabla-facturas-existentes" class="ui table">
                        <thead>
                            <tr>
                                <th>Nro. Factura</th>
                                <th>Cuota</th>
                                <th>Total</th>                            
                            </tr>

                        </thead>
                        <tbody>
                            <ui:repeat value="#{registroCobrosManBean.lstDetFactExistentes}" var="detfactex" varStatus="detfactexStatus">
                                <td>Cuota #{detfactex.factura.talonarioFactura.codEstablecimiento}/#{detfactex.factura.nroFactura}</td>
                                <td>
                                    <h:outputText value="#{detfactex.descripcion}">
                                        <f:convertNumber pattern="###,###,###,###" />
                                    </h:outputText>
                                </td>
                                <td>
                                    <h:outputText value="#{detfactex.factura.total}">
                                        <f:convertNumber pattern="###,###,###,###" />
                                    </h:outputText>
                                </td>
                            </ui:repeat>
                        </tbody>
                    </table>
                </p>
               
            </div>
            <div class="actions">
                <div class="ui black deny button">
                    Nope
                </div>
                <div class="ui positive right labeled icon button">
                    Yep, that's me
                    <i class="checkmark icon"></i>
                </div>
            </div>
        </h:form>
        <script type="text/javascript">
            $('#btn-reg').click(function () {
                $('#form-acciones\\:cml-reg-cobro').click();
//                $('#form-acciones\\:cml-dlg-fin-trans').modal('show');
            });
            $('#boton-contado').click(function () {
                $('#boton-contado').removeClass('basic');
                $('#boton-credito').addClass('basic');
                $('#campo-cont-cred').val('cont');
            });
            $('#boton-credito').click(function () {
                $('#boton-contado').addClass('basic');
                $('#boton-credito').removeClass('basic');
                $('#campo-cont-cred').val('cred');
            });
            $('#dlg-seleccion-cuota').modal();
            $('#btn-seleccion-cuota').click(function () {
                $('#dlg-seleccion-cuota').modal('show');
            });
            var timeOut = 0;
            $('#txf-buscar').on('input', function () {
                clearTimeout(timeOut);
                timeOut = setTimeout(function () {
                    $('#form-filtro\\:cl-buscar').click();
                    modoNuevo();
                }, 500);
            });

            $('#tx-busq-susc')
                    .search({
                        apiSettings: {
                            url: '//' + location.host + restRootPath + '/buscarsuscripcion?q={query}'
                        },
                        fields: {
                            results: 'lstSusc',
                            title: 'tituloItem',
                            description: 'descripcionItem'
                        },
                        searchFullText: true,
                        minCharacters: 3,
                        onSelect: function (result, response) {
                            console.log("seleccionada suscripcion");
                            $('#form-datos\\:txf-suscripcion').val(result.id);
                            $('#form-datos\\:cmdlk-selec-susc').click();
                        }
                    });
            

            function calcularTotal() {
                var idsdetallecobrar = [];
                console.log("json seleccionado calculo cobro");
                $("[id^='chkdetfact']").each(function (index, value) {
                    var idcheck = $(this).attr('id');
                    var iddetafact = idcheck.substring(11);
                    console.log("Id cuota extraido: "+iddetafact);
                    if ($(this).is(':checked')) {
                        console.log("se agrega id cuota "+iddetafact);
                        idsdetallecobrar.push(parseInt(iddetafact));
                    }
                });
                if (idsdetallecobrar.length > 0) {
                    $('#btn-reg').show();
                } else {
                    $('#btn-reg').hide();
                }
                $('#form-detalle\\:iddetalles-cobrar').val(JSON.stringify(idsdetallecobrar));
                $('#form-detalle\\:cmd-calc-total').click();
            }

            $(document).ready(function () {
                $('#cmb-busq-susc')
                    .dropdown({
                        apiSettings: {
                            url: '//' + location.host + restRootPath + '/buscsuscdropdown?q={query}'
                        },
                        onChange: function(){
//                            $('#form-datos\\:txf-suscripcion').val(result.id);
                            $('#form-datos\\:cmdlk-selec-susc').click();
                            console.log("Seleccion suscripcion");
                        }
                    });
                
                $(".ui.calendar").calendar({
                    type: 'date',
                    text: {
                        days: ['D', 'L', 'M', 'M', 'J', 'V', 'S'],
                        months: ['Enero', 'Febrero', 'Marzo', 'Abril', 'Mayo', 'Junio', 'Julio', 'Agosto', 'Septiembre', 'Octubre', 'Noviembre', 'Diciembre'],
                        monthsShort: ['Ene', 'Feb', 'Mar', 'Abr', 'May', 'Jun', 'Jul', 'Ago', 'Sep', 'Oct', 'Nov', 'Dic'],
                        today: 'Hoy',
                        now: 'Ahora',
                        am: 'AM',
                        pm: 'PM'
                    }
                });
                $('.message .close').on('click', function () {
                    $(this).closest('.message').transition('fade');
                });
                console.log("document ready");
                console.log($("#form-detalle\\:iddetalles-cobrar").val());
                if ($("#form-detalle\\:iddetalles-cobrar").val().length !== 0) {
                    var idsdetafact = JSON.parse($("#form-detalle\\:iddetalles-cobrar").val());
                    var longitud = idsdetafact.length;
                    console.log(idsdetafact);
                    for (var i = 0; i &lt; longitud; i++){
                        $('#chkdetfact-' + idsdetafact[i]).prop('checked', true);
                    }
                }
                if ($('#cuerpo-tabla-detalle').children().length !== 0) {
                    if ($('#form-datos\\:id-transaccion').val().length !== 0) {
                        $('#btn-reg').show();
//                        $('#form-acciones\\:btn-reg').show();
//                        $('#btn-reg').css('display','block');
                    }
                }
                comprobarActivacionCheck();
            });

            function desactivarCampos(d) {
                $('#fecha-factura').prop('disabled', d);
                $("[id^='chkdetfact']").each(function (index, value) {
                    $(this).prop('disabled', d);
                });
                if (d) {
                    $('#txf-buscar-cli').addClass('disabled');
                    $('#fecha-factura').addClass('disabled');
                    $('#btn-reg').addClass('disabled');
                    $('#cmb-busq-susc').addClass('disabled');
                } else {
                    $('#txf-buscar-cli').removeClass('disabled');
                    $('#cmb-busq-susc').removeClass('disabled');
//                    $('#form-acciones\\:btn-reg').removeClass('disabled');
                    $('#btn-reg').removeClass('disabled');
                    $('#btn-reg').hide();
                }
            }

            function ajaxReiniciarCampos(data) {
                var s=data.status;
                switch(s){
                    case 'success':{
                            console.log("reiniciar");
                            $('#in-buscar-susc').val('');
                            $('#cmb-busq-susc').dropdown('clear');
                            desactivarCampos(false);
                            mostrarMsgSinCuotas(false);
                            break;
                    }
                }
                
            }

            function ajaxRegistrarCobro(data) {
                console.log("ajax registro cobro");
                var status = data.status;
                console.log("ajax status: " + status);
                switch (status) {
                    case 'begin':
                    {
                        console.log('begin ajax');
//                            $('#form-acciones\\:btn-reg').addClass('loading');
//                            $('#form-acciones\\:btn-reg').addClass('disabled');
                        $('#btn-reg').addClass('loading');
                        $('#btn-reg').addClass('disabled');
                        break;
                    }
                    case 'success':
                    {
                        console.log('success ajax');
                        $('#btn-reg').removeClass('loading');
                        $('#btn-reg').removeClass('disabled');
//                            $('#form-acciones\\:btn-reg').removeClass('loading');
//                            $('#form-acciones\\:btn-reg').removeClass('disabled');

//                            $('#form-acciones\\:btn-reg').hide();
                        $('#btn-reg').hide();
//                            $('#form-acciones\\:btn-reg').css('display','none');
                        desactivarCampos(true);
                        mostrarMsg('Registrar cobro');
                        break;
                    }
                    case 'error':
                    {
//                            $('#form-acciones\\:btn-reg').removeClass('loading');
//                            $('#form-acciones\\:btn-reg').removeClass('disabled');
                        $('#btn-reg').removeClass('loading');
                        $('#btn-reg').removeClass('disabled');
                        break;
                    }
                }
            }

            function mostrarMsg(titulo) {
                $('#titulo-msg').html(titulo);
                if ($('#msg-status').css('display') === 'none') {
                    $('#msg-status').transition('fade');
                }
            }

            function mostrarMsgSinCuotas(mostrar) {
                if (mostrar) {
                    if ($('#msg-sin-cuotas').css('display') === 'none') {
                        $('#msg-sin-cuotas').transition('fade');
                    }
                } else {
                    if ($('#msg-sin-cuotas').css('display') !== 'none') {
                        $('#msg-sin-cuotas').transition('fade');
                    }
                }
            }

            function ajaxComprobarExistDetalle(data) {
                var stat = data.status;
                switch (stat) {
                    case 'begin':
                    {
                        $('#sgm-cargando-tabla').show();
                        break;
                    }
                    case 'complete':
                    {
                        $('#sgm-cargando-tabla').hide();
                        break;
                    }
                    case 'success':
                    {
                        comprobarActivacionCheck();
                        activarChecksConFacturas();
                        if ($('#cuerpo-tabla-detalle').children().length === 0) {
                            mostrarMsgSinCuotas(true);
                            $('#btn-reg').hide();
                        } else {
//                                $('#form-acciones\\:btn-reg').show();
                            $('#btn-reg').show();
//                                $('#btn-reg').css('display','block');
                            mostrarMsgSinCuotas(false);
                        }
                        break;
                    }
                }
            }
            function comprobarActivacionCheck(){
                $('#form-detalle\\:tabla-detalle tbody tr').each(function(index, value){
                            var idfila = $(this).attr('id');
                            var idfilaextract = idfila.substring(9);
//                            var idcuota=parseInt(idfilaextract);
                            if($(this).hasClass("error")){
                                $('#chkdetfact-'+idfilaextract).prop('disabled', true);
                                console.log("Sin factura");
                            }else{
                                $('#chkdetfact-'+idfilaextract).prop('disabled', false);
                                console.log("con factura");
                            }
                        });
            }
            function activarChecksConFacturas(){
                $('#form-detalle\\:tabla-detalle tbody tr').each(function(index, value){
                            var idfila = $(this).attr('id');
                            var idfilaextract = idfila.substring(9);
//                            var idcuota=parseInt(idfilaextract);
                            if(!$(this).hasClass("error")){
                                $('#chkdetfact-'+idfilaextract).prop('checked', true);
                                console.log("con factura, activarcheck");
                            }
                        });
            }
        </script>
    </ui:define>

</ui:composition>
